###############################################################################
# UsersToday.pm (Users Today - Sources)                                       #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use strict;
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION         = '2.7.00';
our $userstodaypmver = 'YaBB 2.7.00 $Revision: 1.6 $';

our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

our (
    $boardindex_template, $boardurl,  $iamadmin,     $iamgmod,
    $iamguest,            $imagesdir, $memberdir,    $myrow_resize,
    $name,                $scripturl, $uid,          $user_ip,
    $username,            $vardir,    $yyaext,       $yymain,
    $yytitle,             %croak,     %security_txt, %uttxt,
    @days,                @utmonths,  %INFO,
);

load_language('Mods/UsersToday');

our (
    $guest_ip,     $guest_view, $log_only, $link_guest,
    $myuserstoday, $plogopt,    $plogopt2, $show_guest_today,
    $showplog,     $utday2,     $utmgday,  $utmgmo,
    $utmgyr,       $view_ips
);

if ( -e "$vardir/Mods/utoday/usrtodayconfig.txt" ) {
    require "$vardir/Mods/utoday/usrtodayconfig.txt";
}

sub userstoday {
    my $newdate = time;
    my ( $utday, $utmon_num, $utyear, $utwday ) =
      ( gmtime($newdate) )[ 3, 4, 5, 6 ];
    $utmon_num += 1;
    my $utsaveyear = $utyear % 100;
    $utyear     = 1900 + $utyear;
    $utmon_num  = sprintf '%02d', $utmon_num;
    $utday      = sprintf '%02d', $utday;
    $utsaveyear = sprintf '%02d', $utsaveyear;

## create files to avoid the initial "dreaded -1" on first load ##
    our ($FILE);
    our ($GUESTFILE);
    if ( !-e "$vardir/Mods/utoday/usertoday.txt" ) {
        fopen( 'FILE', '>', "$vardir/Mods/utoday/usertoday.txt" );
        print {$FILE} "$utmon_num|$utday|$utsaveyear|$utwday\n"
          or croak "$croak{'print'} FILE";
        print {$FILE} "$utday\n" or croak "$croak{'print'} FILE";
        fclose('FILE');
    }
    if ( !-e "$vardir/Mods/utoday/guesttoday.txt" ) {
        fopen( 'GUESTFILE', '>', "$vardir/Mods/utoday/guesttoday.txt" );
        print {$GUESTFILE} "$utday\n" or croak "$croak{'print'} GUESTFILE";
        fclose('GUESTFILE');
    }
    if ( !-e "$vardir/Mods/utoday/uttotal.txt" ) {
        fopen( 'UTTOTAL', '>', "$vardir/Mods/utoday/uttotal.txt" );
        fclose('UTTOTAL');
    }
    if ( !-e "$vardir/Mods/utoday/utstats.txt" ) {
        fopen( 'UTSTATS', '>', "$vardir/Mods/utoday/utstats.txt" );
        fclose('UTSTATS');
    }
    fopen( 'FILE', '<', "$vardir/Mods/utoday/usertoday.txt" );
    my @utoday = <$FILE>;
    fclose('FILE');
    my $usertodaycount  = @utoday;
    my $usertoday       = q{};
    my $usertodaycount2 = 0;
    my $inserted_1      = q{};
    my $inserted_2      = q{};

    for my $aa ( 3 .. $#utoday ) {
        $utoday[$aa] =~ s/\n//igxsm;
        my $utname = $utoday[$aa];

        if ($utname) {
            load_user($utname);
            if ( $utname eq $username ) { $inserted_1 = 'true'; }
            if ( -e "$memberdir/$utname.vars" && $utname eq $utname ) {
                $inserted_2 = 'true';
            }
        }
        {
            no strict qw(refs);
            if ( ${ $uid . $utname }{'stealth'} && ( $iamadmin || $iamgmod ) ) {
                $usertoday .= quick_links($utname) . q~*, ~;
                $usertodaycount2++;
            }
            elsif ( !${ $uid . $utname }{'stealth'} && ${ $uid . $utname }{'realname'} ) {
                $usertoday .= quick_links($utname) . q~, ~;
                $usertodaycount2++;
            }
        }
    }
    $usertodaycount = $usertodaycount2;
    if ( !$iamguest && ( !$inserted_1 || $inserted_2 ) ne 'true' ) {
        if ( $inserted_1 ne 'true' ) {
            fopen( 'FILE', '>>', "$vardir/Mods/utoday/usertoday.txt" );
            print {$FILE} "$username\n" or croak "$croak{'print'} FILE";
            fclose('FILE');
        }
        elsif ( -e ("$memberdir/$username.vars")
            && ( !$inserted_2 || $inserted_2 ne 'true' ) )
        {
            fopen( 'FILE', '>>', "$vardir/Mods/utoday/usertoday.txt" );
            print {$FILE} "$name\n" or croak "$croak{'print'} FILE";
            fclose('FILE');
        }
    }
    elsif ( !$iamguest
        && $inserted_1
        && $inserted_1 eq 'true'
        && ( !$inserted_2 || $inserted_2 ne 'true' ) )
    {
        fopen( 'FILE', '>>', "$vardir/Mods/utoday/usertoday.txt" );
        print {$FILE} "$username\n" or croak "$croak{'print'} FILE";
        fclose('FILE');
    }
    elsif (!$iamguest
        && ( !$inserted_1 || $inserted_1 ne 'true' )
        && $inserted_2 eq 'true' )
    {
        fopen( 'FILE', '>>', "$vardir/Mods/utoday/usertoday.txt" );
        print {$FILE} "$username\n" or croak "$croak{'print'} FILE";
        fclose('FILE');
    }
    $usertoday =~ s/,\s \Z//xsm;
    my $userstoday = q{};
    if ( $usertodaycount == 1 ) {
        $userstoday =
          qq~$uttxt{'1'}<b>$usertodaycount</b>$uttxt{'3'}<br />$usertoday~;
    }
    else {
        $userstoday =
          qq~$uttxt{'1a'}<b>$usertodaycount</b>$uttxt{'3a'}<br />$usertoday~;
    }
## Reading the guests today file ##
    my $g_inserted = q{};
    fopen( 'GUESTFILE', '<', "$vardir/Mods/utoday/guesttoday.txt" );
    my @gtoday = <$GUESTFILE>;
    fclose('GUESTFILE');
    my $guesttodaycount = @gtoday;
    my $guesttoday      = q~<!-- Not listing IP addresses -->~;
    for my $g ( 1 .. $#gtoday ) {
        $gtoday[$g] =~ s/\n//igxsm;
        my $g_ip = $gtoday[$g];
        if ( $g_ip eq $user_ip ) { $g_inserted = 'true'; }
        if ( $view_ips && ( $iamadmin || $iamgmod ) ) {
            $guesttoday .= $g_ip;
            if ( $guesttodaycount > 1 ) { $guesttoday .= q~, ~; }
        }
        else { $guesttoday = q~<!-- Not listing IP addresses -->~; }
    }
    $guesttodaycount = $guesttodaycount - 1;
    my $guesttrailtext = qq~$uttxt{'2c'}<br />~;
    if ( $view_ips && ( $iamadmin || $iamgmod ) ) {
        if ( $guesttodaycount == 1 ) {
            $guesttrailtext = qq~$uttxt{'2b'}<br />~;
        }
        else { $guesttrailtext = qq~$uttxt{'2c'}<br />~; }
    }
    else {
        if   ( $guesttodaycount == 1 ) { $guesttrailtext = $uttxt{'2'}; }
        else                           { $guesttrailtext = $uttxt{'2a'}; }
    }
    if ( $g_inserted ne 'true' && $iamguest ) {
        fopen( 'GUESTFILE', '>>', "$vardir/Mods/utoday/guesttoday.txt" );
        print {$GUESTFILE} "$user_ip\n" or croak "$croak{'print'} GUESTFILE";
        fclose('GUESTFILE');
    }
## Prepare data from usertoday.txt and guesttoday.txt for writing to log file ##
    my $onlinetoday = q{};
    my $gueststoday = q{};
    if ( $utoday[1] != $utday || $gtoday[0] != $utday ) {
        our ($YFILE);
        fopen( 'YFILE', '<', "$vardir/Mods/utoday/usertoday.txt" );
        my @usersyest = <$YFILE>;
        fclose('YFILE');
        my $usercount = $#usersyest - 1;
        our ($YGUESTFILE);
        fopen( 'YGUESTFILE', '<', "$vardir/Mods/utoday/guesttoday.txt" );
        my @guestyest = <$YGUESTFILE>;
        fclose('YGUESTFILE');
        my $guestcount = $#guestyest;
        my ( $yestmon, $yestday, $yestyear, $yestdoy ) =
          split /[|]/xsm, $usersyest[0];
        chomp $yestdoy;
## Add yesterday's user and guest count to log file ##
        my ( $memcount, $latestmember ) = membership_get();
        my $mempercent = ( $usertodaycount / $memcount ) * 100;
        $mempercent = sprintf '%.2f', $mempercent;
        our ($UTTOTAL);
        fopen( 'UTTOTAL', '>>', "$vardir/Mods/utoday/uttotal.txt" );
        print {$UTTOTAL}
"$yestmon|$yestday|$yestyear|$yestdoy|$usercount|$mempercent|$guestcount\n"
          or croak "$croak{'print'} UTTOTAL";
        fclose('UTTOTAL');
## Check stats file to see if it needs updating ##
        our ($UTSTATS);
        fopen( 'UTSTATS', '<', "$vardir/Mods/utoday/utstats.txt" );
        my @utstats = <$UTSTATS>;
        fclose('UTSTATS');
        chomp @utstats;
        $onlinetoday = q{};
        $gueststoday = q{};

        my ( $utmostuser,  $utmumo,  $utmuday,  $utmuyr )  = ( 0, 0, 0, 0 );
        my ( $utmostguest, $utmgmog, $utmgdayg, $utmgyrg ) = ( 0, 0, 0, 0 );
        my ( $uttotaluser, $uttotalguest, $utlogdays, $utavguser, $utavgguest )
          = ( 0, 0, 0, 0, 0 );
        if (@utstats) {
            chomp $utstats[0];
            chomp $utstats[1];
            ( $utmostuser, $utmumo, $utmuday, $utmuyr ) =
              split /[|]/xsm, $utstats[0];
            ( $utmostguest, $utmgmog, $utmgdayg, $utmgyrg ) =
              split /[|]/xsm, $utstats[1];
            $uttotaluser  = $utstats[2];
            $uttotalguest = $utstats[3];
            $utlogdays    = $utstats[4];

            if ( $utmostuser && $usercount >= $utmostuser ) {
                $utmostuser = $usercount;
                $utmumo     = $yestmon;
                $utmuday    = $yestday;
                $utmuyr     = $yestyear;
            }
            if ( $utmostguest && $guestcount >= $utmostguest ) {
                $utmostguest = $guestcount;
                $utmgmog     = $yestmon;
                $utmgdayg    = $yestday;
                $utmgyrg     = $yestyear;
            }
        }
        $uttotaluser  += $usercount;
        $uttotalguest += $guestcount;
        $utlogdays  = $utlogdays + 1;
        $utavguser  = ( $uttotaluser / $utlogdays );
        $utavguser  = sprintf '%.2f', $utavguser;
        $utavgguest = ( $uttotalguest / $utlogdays );
        $utavgguest = sprintf '%.2f', $utavgguest;
        my $stats = << "STATS";
$utmostuser|$utmumo|$utmuday|$utmuyr
$utmostguest|$utmgmog|$utmgdayg|$utmgyrg
$uttotaluser
$uttotalguest
$utlogdays
$utavguser
$utavgguest
$memcount

STATS
        fopen( 'UTSTATS', '>', "$vardir/Mods/utoday/utstats.txt" );
        print {$UTSTATS} $stats or croak "$croak{'print'} UTSTATS";
        fclose('UTSTATS');

## Clear usertoday.txt for new day ##
        my $today = << "STATS";
$utmon_num|$utday|$utsaveyear|$utwday
$utday

STATS
        fopen( 'FILE', '>', "$vardir/Mods/utoday/usertoday.txt" );
        print {$FILE} $today or croak "$croak{'print'} FILE";
        fclose('FILE');
## Clear guesttoday.txt for new day ##
        fopen( 'GUESTFILE', '>', "$vardir/Mods/utoday/guesttoday.txt" );
        print {$GUESTFILE} "$utday\n" or croak "$croak{'print'} GUESTFILE";
        fclose('GUESTFILE');
    }
    if ($show_guest_today) {
        $onlinetoday = qq~$uttxt{'4'}$uttxt{'4a'}~;
        if (   ( $iamadmin || $iamgmod )
            && $guest_ip
            && $link_guest )
        {
            if ( $guesttodaycount == 1 ) {
                $gueststoday =
qq~$uttxt{'1'}<a href="$boardurl/AdminIndex.$yyaext?action=userstoday" style="color: red; text-decoration: underline;"><b>$guesttodaycount</b></a>$guesttrailtext$guesttoday<br />~;
            }
            else {
                $gueststoday =
qq~$uttxt{'1a'}<a href="$boardurl/AdminIndex.$yyaext?action=userstoday" style="color: red; text-decoration: underline;"><b>$guesttodaycount</b></a>$guesttrailtext$guesttoday<br />~;
            }
        }
        else {
            if ( $guesttodaycount == 1 ) {
                $gueststoday =
qq~$uttxt{'1'}<b>$guesttodaycount</b>$guesttrailtext$guesttoday<br />~;
            }
            else {
                $gueststoday =
qq~$uttxt{'1a'}<b>$guesttodaycount</b>$guesttrailtext<br />$guesttoday~;
            }
        }
    }
    else {
        $onlinetoday = $uttxt{'4a'};
        $gueststoday = q~<!-- Not Available -->~;
    }
    my $row_resize    = q{};
    my $my_userstoday = q{};
    if ( $log_only || ( $iamguest && $guest_view != 1 ) ) {
        $row_resize = q{};
        $userstoday = q~<!--Not Available-->~;
    }
    elsif ( ( $iamguest && $guest_view == 1 ) || $username ne 'Guest' ) {
        if ( $plogopt == 1 ) {
            if (   ( $plogopt2 == 0 && $iamadmin )
                || ( $plogopt2 == 1 && ( $iamadmin || $iamgmod ) )
                || ( $plogopt2 == 2 && !$iamguest )
                || ( $plogopt2 == 3 ) )
            {
                $showplog =
qq~<a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;
            }
            else { $showplog = q~<!--Not for you to see-->~; }
        }
        else { $showplog = q~<!--Not for you to see-->~; }
        $row_resize    = $myrow_resize;
        $my_userstoday = $myuserstoday;
        $my_userstoday =~ s/\Q{yabb onlinetoday}\E/$onlinetoday/xsm;
        $my_userstoday =~ s/\Q{yabb gueststoday}\E/$gueststoday/xsm;
        $my_userstoday =~ s/\Q{yabb myuserstoday}\E/$userstoday/xsm;
        $my_userstoday =~ s/\Q{yabb showplog}\E/$showplog/xsm;
    }
    else {
        $row_resize = q{};
        $userstoday = q~<!--Not Available-->~;
    }
    $boardindex_template =~ s/\Q{yabb row_resize}\E/$row_resize/gxsm;
    $boardindex_template =~ s/\Q{yabb userstoday}\E/$my_userstoday/gxsm;
    return;
}

sub show_utlog {
    if ( $plogopt == 1 ) {
        if (   ( ( !$plogopt2 || $plogopt2 == 0 ) && $iamadmin )
            || ( $plogopt2 == 1 && ( $iamadmin || $iamgmod ) )
            || ( $plogopt2 == 2 && !$iamguest )
            || ( $plogopt2 == 3 ) )
        {
            $showplog =
qq~<br /><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;
        }
        else { fatal_error( $security_txt{'1'} ); }
    }
    else { fatal_error( $security_txt{'1'} ); }

    load_language('Mods/UsersToday');
    $yytitle = $uttxt{'16'};
    my $get_log_row = q{};
    my $border      = q{};
    my $tmpa        = 1;
    my $endpage     = 0;
    my $max_show    = 180;
    my $pages       = q{};
    if ( -e "$vardir/Mods/utoday/uttotal.txt" ) {
        our ($TOTUSER);
        fopen( 'TOTUSER', '<', "$vardir/Mods/utoday/uttotal.txt" );
        my @totusers = <$TOTUSER>;
        fclose('TOTUSER');
        chomp @totusers;
        my $countlog = @totusers;
        if ( $countlog > 1 ) {
            $border = q~; border-right:solid thin #000~;
        }
        my $newstart = $INFO{'newstart'} || 0;
        my $max_end = $#totusers;
        $endpage = $newstart + $max_show;
        if ( ( $newstart + $max_show ) > $max_end ) { $endpage = $max_end; }

        my $coltest     = $newstart + $max_show / 2;
        my $column_stop = int $coltest;
        if ( $coltest <= $max_end && $coltest % 2 != 0 ) {
            $column_stop = 1 + int $coltest;
        }
        elsif ( $coltest > $max_end ) {
            my $coltest2 = $max_end - $newstart;
            if ( $coltest2 % 2 != 0 ) {
                $column_stop = int( 1 + $newstart + $coltest2 / 2 );
            }
            else { $column_stop = 1 + int( $newstart + $coltest2 / 2 ); }
        }

        for my $t ( $newstart .. $endpage ) {
            my ( $utmonth, $utday, $utyear, $utdow, $totuser, $mempercent,
                $totguest )
              = split /[|]/xsm, $totusers[$t];
            my $logtime          = stringtotime(qq~$utmonth/$utday/$utyear~);
            my $dateformat_log_a = timeformatcal( $logtime, 0 );
            my $logdate          = qq~$days[$utdow], $dateformat_log_a~;
            my $logdate2         = q~<!--Blank-->~;
            $mempercent =
qq~<span style="color: red; font-style: italic;">($mempercent)</span>~;
            if ( $t == $column_stop ) {
                $get_log_row .= qq~       </table>
            </td>
            <td style="width:50%; vertical-align:top; padding:0 1em" class="windowbg2">
                <table>
                    <colgroup>
                        <col style="width:25%" />
                        <col style="width:15%" />
                        <col style="width:10%" />
                    </colgroup>
                    <tr>
                        <td><b>$uttxt{'13'}</b></td>
                        <td class="center"><b>$uttxt{'14'}&nbsp;$uttxt{'14a'}</b></td>
                        <td class="center"><b>$uttxt{'15'}</b></td>
                    </tr>~;
            }
            $get_log_row .= qq~
                    <tr>
                        <td>$logdate</td>
                        <td class="center"><span style="font-size: 10px;">$totuser&nbsp;$mempercent</span></td>
                        <td class="center"><span style="font-size: 10px;">$totguest</span></td>
                    </tr>~;
        }
        my $logdisplaynum = 8;
        my $startpage     = 0;
        $newstart = ( int( $newstart / $max_show ) ) * $max_show;
        if ( $newstart >= ( ( $logdisplaynum - 1 ) * $max_show ) ) {
            $startpage = $newstart - ( ( $logdisplaynum - 1 ) * $max_show );
            $tmpa = int( $startpage / $max_show ) + 1;
        }
        if ( $max_end >= $newstart + ( $logdisplaynum * $max_show ) ) {
            $endpage = $newstart + ( $logdisplaynum * $max_show );
        }
        else { $endpage = $max_end; }
        $startpage ||= 0;
        if ( $startpage > 0 ) {
            $pages =
qq~<a href="$scripturl?action=showlog;newstart=0" class="norm">1</a>&nbsp;...&nbsp;~;
        }
        if ( $startpage == $max_show ) {
            $pages =
qq~<a href="$scripturl?action=showlog;newstart=0" class="norm">[1]</a>&nbsp;~;
        }
        foreach my $counter ( $startpage .. ( $endpage - 1 ) ) {
            if ( $counter % $max_show == 0 ) {
                $pages .=
                  $newstart == $counter
                  ? qq~<b>[$tmpa]</b>&nbsp;~
                  : qq~<a href="$scripturl?action=showlog;newstart=$counter" class="norm">$tmpa</a>&nbsp;~;
                $tmpa++;
            }
        }
    }
    $yymain .= qq~
    <table class="tabtitle tabtitle-text">
         <tr>
            <td style="width:25%; padding-left:1%">$uttxt{'page'}: $pages&nbsp;</td>
            <td class="center"><b>$uttxt{'16'}</b></td>
        </tr>
    </table>
    <table class="bordercolor" style="width:100%">
        <tr>
            <td style="width:50%; vertical-align:top; padding:0 1em$border" class="windowbg2">
                <table>
                    <colgroup>
                        <col style="width:25%" />
                        <col style="width:15%" />
                        <col style="width:10%" />
                    </colgroup>
                    <tr>
                        <td><b>$uttxt{'13'}</b></td>
                        <td class="center"><b>$uttxt{'14'}&nbsp;$uttxt{'14a'}</b></td>
                        <td class="center"><b>$uttxt{'15'}</b></td>
                    </tr>
$get_log_row
                </table>
            </td>
        </tr>
    </table>~;
    template();
    exit;
}

1;
